; F4HBG's script to remotely control HP/Agilent E4406A VSA
; v1.3 05/2014

#include <GUIConstantsEx.au3>
#include <MsgBoxConstants.au3>
#Include <File.au3>

Main()

Func Main()

    Local $e4406a_config_filename="config.ini"
    Local $mode_e4406a_config = 128 ; 128 utf8 readonly
    Local $file_e4406a_config = FileOpen($e4406a_config_filename, $mode_e4406a_config)
    Local $read_e4406a_config = FileRead($file_e4406a_config)
    Local $e4406a_config_items = StringSplit(StringStripCR($read_e4406a_config), @LF)
    FileClose ($file_e4406a_config)

    For $y = 1 To $e4406a_config_items[0]
		 ;ConsoleWrite("$e4406a_config_items[" & $y & "]=" & $e4406a_config_items[$y] & @LF)
    Next

    TCPStartup() ; Start the TCP service.

    ; Register OnAutoItExit to be called when the script is closed.
    OnAutoItExitRegister("OnAutoItExit")

    ; Assign Local variables.
    Local $sIPAddress = $e4406a_config_items[1] ; E4406A IP Address.
    Local $iPort = $e4406a_config_items[2] ; Port used for the connection.

	; Set the Ext RF Attenuation if needed
	If $e4406a_config_items[3] <> 0 Then
		 EXT_ATTEN($sIPAddress, $iPort, $e4406a_config_items[3])
	EndIf

    #region GUI
    Local $hGUI = GUICreate("E4406A", 290, 250)

    Local $iBtnSPAN10 = GUICtrlCreateButton("SPAN 10MHz", 10, 10, 130, 22)

    Local $iBtnMARKERSEARCH = GUICtrlCreateButton("MARKER SEARCH", 150, 10, 130, 22)

    Local $iBtnAUTOZOOM = GUICtrlCreateButton("AUTO ZOOM", 10, 40, 130, 22)

    Local $iBtnMARKERCENTER = GUICtrlCreateButton("MARKER CENTER", 150, 40, 130, 22)

    Local $iBtnZOOMI10 = GUICtrlCreateButton("ZOOM / 10", 10, 70, 130, 22)

    Local $iBtnZOOMX10 = GUICtrlCreateButton("ZOOM X 10", 150, 70, 130, 22)

    Local $iBtnMINUS10000 = GUICtrlCreateButton("-10KHz", 10, 100, 130, 22)

    Local $iBtnPLUS10000 = GUICtrlCreateButton("+10KHz", 150, 100, 130, 22)

    Local $iBtnMINUS1000 = GUICtrlCreateButton("-1KHz", 10, 130, 130, 22)

    Local $iBtnPLUS1000 = GUICtrlCreateButton("+1KHz", 150, 130, 130, 22)

    Local $iBtnMINUS100 = GUICtrlCreateButton("-100Hz", 10, 160, 130, 22)

    Local $iBtnPLUS100 = GUICtrlCreateButton("+100Hz", 150, 160, 130, 22)

    Local $iBtnMINUS10 = GUICtrlCreateButton("-10Hz", 10, 190, 130, 22)

    Local $iBtnPLUS10 = GUICtrlCreateButton("+10Hz", 150, 190, 130, 22)

    Local $iBtnMINUS1 = GUICtrlCreateButton("-1Hz", 10, 220, 130, 22)

    Local $iBtnPLUS1 = GUICtrlCreateButton("+1Hz", 150, 220, 130, 22)

    GUISetState(@SW_SHOW, $hGUI)

    While 1
        Switch GUIGetMsg()
            Case $GUI_EVENT_CLOSE
                ExitLoop
            Case $iBtnSPAN10
                GUISetState(@SW_DISABLE, $hGUI)
                SPAN10($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMARKERSEARCH
                GUISetState(@SW_DISABLE, $hGUI)
                MARKERSEARCH($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMARKERCENTER
                GUISetState(@SW_DISABLE, $hGUI)
                MARKERCENTER($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnAUTOZOOM
                GUISetState(@SW_DISABLE, $hGUI)
                AUTOZOOM($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnZOOMI10
                GUISetState(@SW_DISABLE, $hGUI)
                ZOOMI10($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnZOOMX10
                GUISetState(@SW_DISABLE, $hGUI)
                ZOOMX10($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMINUS10000
                GUISetState(@SW_DISABLE, $hGUI)
                MINUS10000($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnPLUS10000
                GUISetState(@SW_DISABLE, $hGUI)
                PLUS10000($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMINUS1000
                GUISetState(@SW_DISABLE, $hGUI)
                MINUS1000($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnPLUS1000
                GUISetState(@SW_DISABLE, $hGUI)
                PLUS1000($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMINUS100
                GUISetState(@SW_DISABLE, $hGUI)
                MINUS100($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnPLUS100
                GUISetState(@SW_DISABLE, $hGUI)
                PLUS100($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMINUS10
                GUISetState(@SW_DISABLE, $hGUI)
                MINUS10($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnPLUS10
                GUISetState(@SW_DISABLE, $hGUI)
                PLUS10($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnMINUS1
                GUISetState(@SW_DISABLE, $hGUI)
                MINUS1($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
            Case $iBtnPLUS1
                GUISetState(@SW_DISABLE, $hGUI)
                PLUS1($sIPAddress, $iPort)
                GUISetState(@SW_ENABLE, $hGUI)
        EndSwitch

        Sleep(10)
    WEnd

    GUIDelete($hGUI)
    #endregion GUI
EndFunc   ;==>MainMenu

Func EXT_ATTEN($sIPAddress, $iPort, $atten)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 200

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:CORR:RF:LOSS "& $atten &@CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
EndFunc   ;==>ATTEN

Func SPAN10($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 200

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SPEC:FREQ:SPAN 10MHz"& @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>SPAN10

Func MARKERSEARCH($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 200

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
EndFunc   ;==>SEARCH

Func MARKERCENTER($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 200

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "CALC:SPEC:MARK:X?"& @CRLF)
    Local $mark_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
    TCPSend($iSocket, "SENS:FREQ:CENT "& $mark_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
EndFunc   ;==>CENTER

Func ZOOMI10($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    ;TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    ;Sleep($delay)
    TCPSend($iSocket, "SPECtrum:FREQuency:SPAN?"& @CRLF)
    Local $spec_span = TCPRecv($iSocket, 1024)
    Sleep($delay)
    $spec_span = $spec_span * 10
    TCPSend($iSocket, "SPEC:FREQ:SPAN "& $spec_span & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>ZOOM

Func ZOOMX10($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    ;TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    ;Sleep($delay)
    TCPSend($iSocket, "SPECtrum:FREQuency:SPAN?"& @CRLF)
    Local $spec_span = TCPRecv($iSocket, 1024)
    Sleep($delay)
    $spec_span = $spec_span / 10
    TCPSend($iSocket, "SPEC:FREQ:SPAN "& $spec_span & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>ZOOM

Func AUTOZOOM($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:X?"& @CRLF)
    Local $mark_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
    TCPSend($iSocket, "SENS:FREQ:CENT "& $mark_freq & @CRLF)
    Sleep($delay)

    TCPSend($iSocket, "SPEC:FREQ:SPAN 500KHz"& @CRLF)
    Sleep($delay)
    Sleep($delay)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:X?"& @CRLF)
    Local $mark_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
    TCPSend($iSocket, "SENS:FREQ:CENT "& $mark_freq & @CRLF)
    Sleep($delay)

    TCPSend($iSocket, "SPEC:FREQ:SPAN 50KHz"& @CRLF)
    Sleep($delay)
    Sleep($delay)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:X?"& @CRLF)
    Local $mark_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
    TCPSend($iSocket, "SENS:FREQ:CENT "& $mark_freq & @CRLF)
    Sleep($delay)

    TCPSend($iSocket, "SPEC:FREQ:SPAN 10KHz"& @CRLF)
    Sleep($delay)
    Sleep($delay)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:MAX"& @CRLF)
    Sleep($delay)
    TCPSend($iSocket, "CALC:SPEC:MARK:X?"& @CRLF)
    Local $mark_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
    TCPSend($iSocket, "SENS:FREQ:CENT "& $mark_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>AUTOZOOM

 Func MINUS10000($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq - 10000
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>MINUS10000

 Func PLUS10000($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq + 10000
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>PLUS10000

 Func MINUS1000($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq - 1000
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>MINUS1000

 Func PLUS1000($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq + 1000
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>PLUS1000

 Func MINUS100($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq - 100
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>MINUS100

 Func PLUS100($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq + 100
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>PLUS100

 Func MINUS10($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq - 10
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>MINUS10

 Func PLUS10($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq + 10
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>PLUS10

 Func MINUS1($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq - 1
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>MINUS1

 Func PLUS1($sIPAddress, $iPort)
    ; Assign a Local variable the socket and connect to a listening socket with the IP Address and Port specified.
    Local $iSocket = TCPConnect($sIPAddress, $iPort)
    Local $iError = 0
    Local $delay = 350

    ; If an error occurred display the error code and return False.
    If @error Then
        ; The server is probably offline/port is not opened on the server.
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not connect, Error code: " & $iError)
        Return False
    EndIf

    ; Send the command.
    TCPSend($iSocket, "SENS:FREQ:CENT?"& @CRLF)
    Local $cent_freq = TCPRecv($iSocket, 1024)
    Sleep($delay)
	Local $new_cent_freq = $cent_freq + 1
    TCPSend($iSocket, "SENS:FREQ:CENT +"& $new_cent_freq & @CRLF)
    Sleep($delay)

    ; If an error occurred display the error code and return False.
    If @error Then
        $iError = @error
        MsgBox(BitOR($MB_SYSTEMMODAL, $MB_ICONHAND), "", "Client:" & @CRLF & "Could not send the data, Error code: " & $iError)
        Return False
    EndIf

    ; Close the socket.
    TCPCloseSocket($iSocket)
 EndFunc   ;==>PLUS1



Func OnAutoItExit()
    TCPShutdown() ; Close the TCP service.
EndFunc   ;==>OnAutoItExit